/*
 *  DielectricMaterial.h
 *  Assignment5
 *
 *  Created by Zach Gildersleeve on 2/20/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef DIELECTRICMATERIAL_H
#define DIELECTRICMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"
//#include "Math.h"
//#include <iostream>
//using namespace std;

class DielectricMaterial : public Material {
	public:
		DielectricMaterial(double newEta, int newPhongTerm);
		DielectricMaterial(double newEta, int newPhongTerm, const Color &newBeersE);
		virtual ~DielectricMaterial() {}
		
		virtual void preprocess() {}
		void shade(Color &result, const RenderContext &context,
				   const Ray &ray, const HitRecord &hit, int depth,
				   const Color &attenuation) const;
		
		DielectricMaterial(const DielectricMaterial &lm);
		DielectricMaterial &operator=(const DielectricMaterial &lm);
		
		inline Color beersAttenuation(double t) const {
			return Color(exp(t * beersE.r), exp(t * beersE.g), exp(t * beersE.b));
		}
		
	private:
		double eta;
		double inverseEta;
		double r0;
		int phongTerm;
		Color beersE;
	
};

#endif