/*
 *  DirectionalLight.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef DIRECTIONALLIGHT_H
#define DIRECTIONALLIGHT_H

#include "Vector.h"
#include "Color.h"
#include "Light.h"

static const double BIG_NUMBER = 1000000000.0;

class DirectionalLight : public Light {
	public:
		DirectionalLight(const Vector &newDirection, const Color &newColor);
		virtual ~DirectionalLight();
		
		virtual void preprocess();
		virtual double getLight(Color &color, Vector &lightDirection,
							  const RenderContext &context,
							  const Point &location) const;
		
		DirectionalLight(const DirectionalLight &dl);
		DirectionalLight &operator=(const DirectionalLight &dl);
	
	private:
		Vector direction;
		Color lightColor;
	
	
};



#endif