/*
 *  PhongMaterial.h
 *  Assignment5
 *
 *  Created by Zach Gildersleeve on 2/20/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PHONGMATERIAL_H
#define PHONGMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"

class PhongMaterial : public Material {
		public:
			PhongMaterial(const Color &newColor, double newKdiffuse, double newKambient, const Color &newSpecColor, int newPhongTerm);
			virtual ~PhongMaterial() {}
			
			virtual void preprocess() {}
			void shade(Color &result, const RenderContext &context,
					   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
			
			PhongMaterial(const PhongMaterial &lm);
			PhongMaterial &operator=(const PhongMaterial &lm);
			
		private:
			Color color;
			double Kambient;
			double Kdiffuse;
			Color specColor;
			int phongTerm;
};

#endif