/*
 *  PinholeCamera.cpp
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/27/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "PinholeCamera.h"

PinholeCamera::PinholeCamera(const Point &newPosition, const Point &newLookat,
							 const Vector &newUp, double newfov) :
							 position(newPosition), lookat(newLookat),
							 up(newUp), fov(newfov) {
	
}

PinholeCamera::~PinholeCamera() {
	
}

void PinholeCamera::preprocess(double aspectRatio) {
	normalDirection = lookat - position;
	normalDirection.normalize();
	
	u = cross(normalDirection, up);
	v = cross(u, normalDirection);
	
	double uLength = tan(fov * 3.14159 / 360.0);
	u.normalize();
	u *= uLength;
	
	double vLength = uLength / aspectRatio;
	v.normalize();
	v *= vLength;
}

void PinholeCamera::makeRay(Ray &ray, const RenderContext &context, double x, double y) const {
	Vector myRayDirection = normalDirection + (u * x) + (v * y);
	myRayDirection.normalize();
	ray = Ray(position, myRayDirection);
}