/*
 *  Plane.cpp
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/31/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Plane.h"
#include <iostream.h>

Plane::Plane(Material *newMaterial, const Vector &newNormal, const Point &newCenter) : Primitive(newMaterial), normalVector(newNormal), center(newCenter) {
	normalVector.normalize();
	d = dot(normalVector, center);
}

Plane::~Plane() {
	
}

bool Plane::intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	/////////////////////<----------------
	// if denom is nearly equal to 0, ray misses
	// denom = plane.normal dot ray.direction

	double denom = dot(normalVector, ray.getDirection());
	
	if (denom < VERY_SMALL && denom > -VERY_SMALL)
		return false;
	else
	{
		// numer = d + plane.normal dot ray.origin
		double numer = dot(normalVector, ray.getOrigin());
		numer = d - numer;
		double t = (numer/denom);
//		double t = 30.0;
		hit.hit(t, this, material);

		return true;
	}
}

void Plane::normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	normal = normalVector;
}

