/*
 *  Sphere.h
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/17/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef SPHERE_H
#define SPHERE_H

#include "Point.h"
#include "Ray.h"
#include "Primitive.h"
#include "Material.h"
#include "Vector.h"
#include "Point.h"
#include "Object.h"
#include "math.h"
#include "HitRecord.h"

class Point;
class Ray;

class Sphere : public Primitive {
	public:
		Sphere(const Point &newCenter, double newRadius);
		Sphere(Material *mat, const Point &newCenter, double newRadius);
		
		virtual ~Sphere();
		
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		
	private:
		Point center;
		double radius;
};
#endif